#include "internal.h"





/****************************************************************************/
int main( int argc, char **argv )
{
  enum test_operation
    operation = UNKNOWN;

  assert( argc >= 1 );
  assert( argv != NULL );

  if( argc == 1 or argc >= 3 )
    operation = HELP;

  if( operation == UNKNOWN )
  {
    if( 0 == strcmp(*(argv+1), "test") )
      operation = TEST;

    if( 0 == strcmp(*(argv+1), "benchmark") )
      operation = BENCHMARK;
  }

  switch( operation )
  {
    case UNKNOWN:
    case HELP:
      puts( "test [test|benchmark]" );
    break;

    case TEST:
      test_abstraction();
      test_freelist();
      test_queue();
      test_ringbuffer();
      test_slist();
      test_stack();
    break;

    case BENCHMARK:
      benchmark_queue();
    break;
  }

  return( EXIT_SUCCESS );
}

