/***** structs *****/
#pragma pack( push, ALIGN_DOUBLE_POINTER )

/***** abstraction tests *****/
struct abstraction_test_dcas_state
{
  volatile atom_t
    *shared_counter;

  atom_t
    local_counter;
};

/***** freelist tests *****/
struct freelist_test_popping_state
{
  struct freelist_state
    *fs,
    *fs_thread_local;
};

struct freelist_test_pushing_state
{
  atom_t
    thread_number;

  struct freelist_state
    *source_fs,
    *fs;
};

struct freelist_test_popping_and_pushing_state
{
  struct freelist_state
    *local_fs,
    *fs;
};

struct freelist_test_counter_and_thread_number
{
  atom_t
    thread_number;

  unsigned long long int
    counter;
};

/***** queue tests *****/
struct queue_test_enqueuing_state
{
  struct queue_state
    *qs;

  atom_t
    thread_number;
};

struct queue_test_dequeuing_state
{
  struct queue_state
    *qs;

  int
    error_flag;
};

struct queue_test_enqueuing_and_dequeuing_state
{
  struct queue_state
    *qs;

  atom_t
    counter,
    thread_number;
};

/***** ringbuffer tests *****/

/***** slist tests *****/
struct slist_thread_start_state
{
  struct slist_state
    *ss;

  struct slist_element
    *se;

  time_t
    duration;

  unsigned long int
    iteration_modulo;
};

/***** stack tests *****/

/***** queue benchmarks *****/
struct queue_benchmark
{
  struct queue_state
    *qs;

  atom_t
    operation_count;
};

#pragma pack( pop )

